/*
 * Copyright (c) 2008 Topspin Communications.  All rights reserved.
 *
 * This software is available to you under a choice of one of two
 * licenses.  You may choose to be licensed under the terms of the GNU
 * General Public License (GPL) Version 2, available from the file
 * COPYING in the main directory of this source tree, or the
 * OpenIB.org BSD license below:
 *
 *     Redistribution and use in source and binary forms, with or
 *     without modification, are permitted provided that the following
 *     conditions are met:
 *
 *      - Redistributions of source code must retain the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer.
 *
 *      - Redistributions in binary form must reproduce the above
 *        copyright notice, this list of conditions and the following
 *        disclaimer in the documentation and/or other materials
 *        provided with the distribution.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS
 * BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN
 * ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
 * CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 *
 * Fork Id: device_list.c 5401 2006-02-14 03:38:30Z roland
 */
/*
 * Copyright (C) 2008 United States Government as represented by the
 * Administrator of the National Aeronautics and Space Administration.
 * All Rights Reserved.
 *
 * $Id: device_list.cxx,v 1.3 2008/05/11 21:24:29 bgreen Exp $
 */

#if HAVE_CONFIG_H
#  include <config.h>
#endif /* HAVE_CONFIG_H */

#include <stdio.h>

#include <endian.h>
#include <byteswap.h>

#include <ibvpp.h>
#include <infiniband/arch.h>

int main(int argc, char *argv[])
{
    try {
        ibv::device_list_ptr dev_list = ibv::get_device_list();

        printf("    %-16s\t   node GUID\n", "device");
        printf("    %-16s\t----------------\n", "------");

        ibv::device_list::iterator dev_it = dev_list->begin();
        while (dev_it != dev_list->end()) {
            printf("    %-16s\t%016llx\n",
                   dev_list->get_device_name(dev_it),
                   (unsigned long long) ntohll(dev_list->get_device_guid(dev_it)));
            ++dev_it;
        }
    } catch (std::exception &e) {
        fprintf(stderr,"error: %s\n", e.what());
        return 1;
    }

    return 0;
}

