/*
 * Copyright (C) 2008 United States Government as represented by the
 * Administrator of the National Aeronautics and Space Administration.
 * All Rights Reserved.
 */

#include <ibvpp_utility.h>

namespace ibv {
    port_iterator find_active_port(
            const port_iterator &s,
            const port_iterator &e)
        throw (std::exception)
    {
        port_iterator it;
        port_attr port_attrs;
        port_ptr port;

        for (it=s; it!=e; ++it) {
            port = *it;
            port->query(&port_attrs);
            if (port_attrs.state == IBV_PORT_ACTIVE)
                break;
        }

        return it;
    }
}

