/*
 * Copyright (C) 2008 United States Government as represented by the
 * Administrator of the National Aeronautics and Space Administration.
 * All Rights Reserved.
 */
#ifndef _ibvpp_utility_h_
#define _ibvpp_utility_h_

#include <ibvpp.h>

namespace ibv {
    port_iterator find_active_port(
            const port_iterator &s,
            const port_iterator &e)
        throw (std::exception);

    inline port_iterator find_active_port(const device_list_ptr &devlist)
        throw (std::exception)
    {
        return find_active_port(devlist->begin_port(),devlist->end_port());
    }

    inline port_iterator find_active_port()
        throw (std::exception)
    {
        device_list_ptr devlist = get_device_list();
        port_iterator pit =
            find_active_port(devlist->begin_port(),devlist->end_port());
        if (pit == devlist->end_port())
            throw error("no active ports found");
        return pit;
    }
}

#endif

